var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "@babel/types"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const t = __importStar(require("@babel/types"));
    function default_1() {
        let count = 0;
        return {
            visitor: {
                //remove imports
                ImportDeclaration(path) {
                    path.remove();
                },
                ExportNamedDeclaration(path) {
                    if (path.node.declaration) {
                        path.replaceWith(path.node.declaration);
                    }
                    else {
                        path.remove();
                    }
                },
                ExportDefaultDeclaration(path) {
                    let type = path.node.declaration.type;
                    if (type === "FunctionDeclaration") {
                        //anonymous function
                        if (!path.node.declaration.id) {
                            path.node.declaration.id = t.identifier("__ANON__" + count);
                            count++;
                        }
                        //named function
                        else {
                            path.replaceWith(path.node.declaration);
                        }
                        return;
                    }
                    if (type === "Identifier") {
                        path.remove();
                        return;
                    }
                    if (type === "ClassDeclaration") {
                        if (!path.node.declaration.id) {
                            path.node.declaration.id = t.identifier("__ANON__" + count);
                            count++;
                        }
                        else {
                            path.replaceWith(path.node.declaration);
                        }
                        return;
                    }
                    //fallback remove it
                    path.remove();
                }
            }
        };
    }
    exports.default = default_1;
});
